/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            audio_encoder.h
 *
 *  Sat Sep 17 18:38:45 CEST 2005
 *  Copyright  2005 Bent Bisballe Nyeng
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *  This file is part of MIaV.
 *
 *  MIaV is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  MIaV is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with MIaV; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
#include "config.h"
#ifndef __MIAV_AUDIO_ENCODER_H__
#define __MIAV_AUDIO_ENCODER_H__

#include "frame.h"
#include "util.h"

#include "thread.h"
#include <pthread.h>

#include "info.h"

#include "liblame_wrapper.h"

class AudioEncoder : public Thread {
public:
  AudioEncoder(FramePriorityQueue *in, pthread_mutex_t *in_mutex, sem_t *in_sem,
               FramePriorityQueue *out, pthread_mutex_t *out_mutex, sem_t *out_sem,
               Info *info);
  ~AudioEncoder();

  void thread_main();

  volatile bool running;

private:
  unsigned int frame_number;

  Info *info;

  // Input/Output queues
  FramePriorityQueue *inputqueue;
  FramePriorityQueue *outputqueue;
  pthread_mutex_t *input_mutex;
  pthread_mutex_t *output_mutex;

  //thread stuff
  sem_t *input_sem;
  sem_t *output_sem;
};


#endif/*__MIAV_AUDIO_ENCODER_H__*/
