/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            dvfile.cc
 *
 *  Thu Jul 28 17:30:48 CEST 2005
 *  Copyright  2005 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *  This file is part of MIaV.
 *
 *  MIaV is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  MIaV is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with MIaV; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
#include "config.h"
#include "dvfile.h"

#include "dv.h"

#include <time.h>

dvfile::dvfile(Info* i)
{
  info = i;
  fp = fopen(TEST_MOVIE, "r");
}

dvfile::~dvfile()
{
  fclose(fp);
}

unsigned char *dvfile::readFrame()
{
  struct timespec ts;
  unsigned char *frame = new unsigned char[DVPACKAGE_SIZE];

  ts.tv_sec = 0;
  ts.tv_nsec = 1000000000L / 25L;	// 1/25s
  nanosleep(&ts, NULL);

  while(fread(frame, DVPACKAGE_SIZE, 1, fp) == 0) {
    fseek(fp, 0L, SEEK_SET);
  }
  
  return frame;
}
