/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            img_encoder.h
 *
 *  Mon Nov 15 19:45:07 CET 2004
 *  Copyright  2004 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 * Originally from:
 * RTVideoRec Realtime video recoder and encoder for Linux
 *
 * Copyright (C) 2004  B. Stultiens
 */

/*
 *    This file is part of MIaV.
 *
 *    MIaV is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MIaV is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MIaV; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
#include "config.h"
#ifndef __RTVIDEOREC_IMGENCODER_H
#define __RTVIDEOREC_IMGENCODER_H

#include <stdio.h>

#include "frame.h"
#include "util.h"

extern "C" {
#include <jpeglib.h>
}

//#include <stdlib.h>
//#include <string.h>

#include "info.h"
#include "file.h"

#define VIDEO_BUFFER_SIZE	(1024*1024)	// FIXME: One size fits all...
#define JPEG_HEADER_PAD 500

class ImgEncoder {
public:
  ImgEncoder(const char* cpr, Info *info);
  ~ImgEncoder();
  void encode(Frame *frame, int quality);
  void writeJPEGFile(int quality,
                     JSAMPLE * image_buffer, // Points to large array of R,G,B-order data 
                     int image_width,        // Number of columns in image 
                     int image_height);      // Number of rows in image 
                     
private:
  File *file;
  Info *info;
  void getRGB(Frame *frame, unsigned char *rgb);
};

#endif /*__RTVIDEOREC_IMGENCODER_H*/

