/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            liblame_wrapper.h
 *
 *  Sat Jul  2 11:11:34 CEST 2005
 *  Copyright  2005 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *  This file is part of MIaV.
 *
 *  MIaV is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  MIaV is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with MIaV; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
#include "config.h"
#ifndef __MIAV_LIBLAME_WRAPPER_H__
#define __MIAV_LIBLAME_WRAPPER_H__

// Use libdv
#include <libdv/dv.h>
#include <libdv/dv_types.h>

// Use liblame
#include <lame/lame.h>

#include "frame.h"
#include "info.h"

#define AUDIO_BUFFER_SIZE DV_AUDIO_MAX_SAMPLES

#define CHANNELS 2
#define INPUT_SAMPLE_RATE 48000
#define OUTPUT_SAMPLE_RATE 48000
#define SAMPLES OUTPUT_SAMPLE_RATE / 25

class LibLAMEWrapper {
public:
  LibLAMEWrapper(Info *info);
  ~LibLAMEWrapper();

  Frame *encode(Frame *dvframe);

  Frame *close(Frame *dvframe);

private:
  unsigned long long calc_bitrate;
  int frame_number;

  Info *info;

  // LAME stuff
  lame_global_flags *gfp;

  // libdv stuff
  dv_decoder_t *decoder;
  int16_t *audio_buffer[2];
};

#endif/*__MIAV_LIBLAME_WRAPPER_H__*/
