/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            mov_encoder.h
 *
 *  Sat Feb 19 14:13:19 CET 2005
 *  Copyright  2005 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 * Originally from:
 * RTVideoRec Realtime video recoder and encoder for Linux
 *
 * Copyright (C) 2004  B. Stultiens
 */

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include "config.h"
#ifndef __RTVIDEOREC_ENCODER_H
#define __RTVIDEOREC_ENCODER_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <vector>
using namespace std;

#include "frame.h"
#include "util.h"

#include "thread.h"
#include <pthread.h>

#include "info.h"

#include "libfame_wrapper.h"
//#include "liblame_wrapper.h"

class MovEncoder : public Thread {
public:
  MovEncoder(volatile bool *r, sem_t *r_sem,
             FrameVectorQueue *in, sem_t *in_sem, pthread_mutex_t *in_mutex,
             FramePriorityQueue *v_out, pthread_mutex_t *v_out_mutex, sem_t *v_out_sem,
             FramePriorityQueue *a_out, pthread_mutex_t *a_out_mutex, sem_t *a_out_sem,
             Info *info);
  ~MovEncoder();

  void thread_main();

  volatile bool *running;

private:
  //  LibFAMEWrapper *fame;
  //  LibLAMEWrapper *lame;

  Info *info;

  // Input/Output queues
  FrameVectorQueue *inputqueue;
  FramePriorityQueue *video_outputqueue;
  FramePriorityQueue *audio_outputqueue;
  pthread_mutex_t *input_mutex;
  pthread_mutex_t *video_output_mutex;
  pthread_mutex_t *audio_output_mutex;

  //thread stuff
  sem_t *input_sem;
  sem_t *video_output_sem;
  sem_t *audio_output_sem;

  sem_t *read_sem;
  
};

#endif

