/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            network.h
 *
 *  Wed Nov  3 21:23:14 CET 2004
 *  Copyright  2004 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *    This file is part of MIaV.
 *
 *    MIaV is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MIaV is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MIaV; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
#include "config.h"
#ifndef __MIAVLIB_NETWORK_H__
#define __MIAVLIB_NETWORK_H__
 
#include "socket.h"
#include "package.h"
#include "info.h"

class Network {
public:
  Network(Socket *gs, Info* ginfo);
  ~Network();

  // Raw communication
  int write(void *buf, int size);
  int read(void *buf, int size);

  // Package communication
  int sendPackage(n_header *h, void* buf, int bufsz);
  int recvPackage(n_header *h, void* buf, int bufsz);

private:
  Info *info;
  Socket *s;
};

#endif/*__NETWORK_H__*/


