/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            server_status.cc
 *
 *  Fri Apr 29 13:58:26 CEST 2005
 *  Copyright  2005 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *    This file is part of MIaV.
 *
 *    MIaV is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MIaV is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MIaV; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
#include <config.h>
#include "server_status.h"

#include <stdio.h>

ServerStatus::ServerStatus(Info *i)
{
  info = i;

  gettimeofday(&oldtime, NULL);
  
  for(int cnt = 0; cnt < BUFFERSIZE; cnt++) {
    frametime[cnt] = 41660;
  }

  gettimeofday(&time, NULL);

  interval = 0;
}

ServerStatus::~ServerStatus()
{
}

void ServerStatus::checkPoint()
{
  for(int cnt = BUFFERSIZE - 1; cnt > 0; cnt--) {
    frametime[cnt] = frametime[cnt-1];
  }
  frametime[0] = (1000000 * time.tv_sec + time.tv_usec) - (1000000 * oldtime.tv_sec + oldtime.tv_usec);

  oldtime.tv_sec = time.tv_sec;
  oldtime.tv_usec = time.tv_usec;

  gettimeofday(&time, NULL);

  interval += frametime[0];
  if(interval > UPD) {
    interval = 0;
    double total = 0.0;
    for(int cnt = 0; cnt < BUFFERSIZE; cnt++) {
      total += (double)frametime[cnt];
    }
    info->info("Status - fps: %f", 1000000.0 / (total / (double)BUFFERSIZE));
  }
  
}

/*
date(1), gettimeofday(2), ctime(3), ftime(3)
*/
