/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            server_status.h
 *
 *  Fri Apr 29 13:58:26 CEST 2005
 *  Copyright  2005 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *    This file is part of MIaV.
 *
 *    MIaV is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MIaV is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MIaV; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
#include "config.h"
#ifndef __MIAV_SERVER_STATUS_H__
#define __MIAV_SERVER_STATUS_H__

#include "info.h"

#include <sys/time.h>

// How many steps to do avarage calculation over.
#define BUFFERSIZE 100

// Interval in us (microseconds)
#define UPD 60 * 1000 * 1000 // 1 minute

class ServerStatus {
public:
  ServerStatus(Info *info);
  ~ServerStatus();

  void checkPoint();

private:
  long long interval;
  Info *info;
  unsigned int frametime[BUFFERSIZE];
  struct timeval time; 
  struct timeval oldtime; 
};

#endif/*__MIAV_SERVER_STATUS_H__*/
